# mongoc_gridfs_bucket_find()

## Synopsis

    mongoc_cursor_t *
    mongoc_gridfs_bucket_find (mongoc_gridfs_bucket_t *bucket,
                               const bson_t *filter,
                               const bson_t *opts);

## Parameters

- `bucket`: A mongoc_gridfs_bucket_t.
- `filter`: A `bson_t` containing the query to execute.
- `opts`: A `bson_t` for query options, supporting all options in mongoc_collection_find_with_opts() excluding `sessionId`.

## Description

Finds file documents from the bucket’s `files` collection.

This function is considered a retryable read operation. Upon a transient error (a network error, errors due to replica set failover, etc.) the operation is safely retried once. If `retryreads` is false in the URI (see mongoc_uri_t) the retry behavior does not apply.

## Returns

A newly allocated mongoc_cursor_t that must be freed with mongoc_cursor_destroy().